# server methods called by client

class GameClient

  def set_playername(name)
    @playername = name
    if $game.connected?
      netsend :recv_set_playername, name
    else
      $chatwidget.write_cmsg "Changed name to #{name}."
    end
  end

  def play_hand(hand)
    return if not connected?
    @log.debug {"playing #{hand}"}
    netsend :recv_play_hand, hand
  end

  # how client tells the server to play a game
  # TODO: craptacular dev version
  def create_game
    $game.xml_board, $game.board = BoardFactory.create_from_file("boards/game_board.xml")
    $game.gametype = DefaultGameType.new
    netsend :recv_game_created, DeltaState.new(:xml_board, :gametype)
    @ui.recv_game_created
  end
end
