module Defs
  # custom themes have a directory here
  THEME_PATH = File.join(".", "themes")

  if defined?(SDL)
    module Gfx
      SDLFLAGS = SDL::HWSURFACE|SDL::SRCALPHA
    end
  end
end

# robot actions, used to mark animation hooks
module Action
  UNDEFINED, PAUSE, MOVE, ROTATE, PUSH, PITDEATH, LASERFIRE, REXPLODE,
  NOTHING, REVIVE, FALLOFF, CRUSH, BOARDLASERS, PLAYERQUIT = (0...14).to_a
  # sleep time before animating this action
  Delays = {
    MOVE => 0.7,
    PAUSE => 0.5,
    ROTATE => 0.5,
    PUSH => 0.8,
    PITDEATH => 0,
    LASERFIRE => 0.5
  }
end

class CheaterError < Exception
end
