# Abstract class for all board elements
# resources should be defined in a catch-all file
class Element
  include Tools
  attr_accessor :image_key

  # Do action at phase and priority
  def execute(phase, priority, row, col); false end

  # do any immediate effets as soon as robot encounters element
  def immediate_effects(row, col); false end

  # initialize data that depends on other elements, such as pit corners
  def init_deps(board, square)
  end

  def to_s
    self.class.to_s
  end
  def inspect; to_s end
  # method to generate a unique hash key for storing images
  def key
    puts "define a key for this class!"
  end
end
