class Pit < Floor
  attr_reader :adj_pits, :corners

  def immediate_effects(row, col)
    robots = $game.get_robots(row, col)
    robots.each { |r| r.die!(Action::PITDEATH) }
  end

  def to_s
    self.class.to_s
  end

  def key
    self.to_s + @adj_pits.to_s + ":" + @corners.to_s
  end

  # looks for adjacent pits for image tiling
  # and corners which aren't pits and are flanked by pits
  def init_deps(board, square)
    @adj_pits, @corners = Sides.new, Sides.new
    # [n,w,s,e] , [nw, sw, se, ne]
    adj, diag = board.surrounding_squares(square)
    adj = adj*2 # cheap ass trick: allows index wrapping for lookahead compares
    faces = Facing.all
    for i in 0...faces.size
      @adj_pits.add(faces[i]) if adj[i].has_pit?
      if not diag[i].has_pit?
        # check adj[i+1] and adj[i] for pits
        if adj[i+1].has_pit? and adj[i].has_pit?
          @corners.add(faces[i]) # this corner should be rendered
        end
      end
    end
  end
end
