class Board

  # initialize the graphics data (load images, etc)
  # also includes misc elements for now (explodies, etc)
  def init_sdl(surf)
    @squares.each {|s| s.init_sdl(surf) }
    $game.images['bang'] = $game.load_image('img_bang')
    $game.images['bang_small'] = $game.load_image('img_bang_small')
  end

  def draw(surf)
    @squares.each {|s| s.draw(surf) }
  end

  def draw_cached(surf)
    @squares.each {|s| s.draw_cached(surf) }
  end

  def draw_top(surf)
    for s in @squares
      next unless s.dirty?
      s.draw_top(surf) 
      s.clean
    end
  end

  def draw_bottom(surf)
    for s in @squares
      s.draw_bottom(surf) if s.dirty?
    end
  end

end
