class LaserSource
  def init_sdl(surf)
    @image_key = key
    return if $game.images[@image_key]

    canvas = SDL::Surface.new(SDL::SWSURFACE, $game.theme['square_size'], 
      $game.theme['square_size'], surf)
    canvas.set_color_key(SDL::SRCCOLORKEY, canvas[0,0])
    img = $game.load_image("img_laser#{@number}_source")
    case @direction
    when N then canvas.put(img, 0, 0)
    when E then rotate(img, canvas, 90)
    when S then rotate(img, canvas, 180)
    when W then rotate(img, canvas, 270)
    end

    # don't forget cross lasers
    case @direction
    when N, S
      if @e + @w > 0
        img = $game.load_image("img_laser#{@e+@w}_beam")
        rotate(img, canvas, 90)
      end
    else
      if @n + @s > 0
        img = $game.load_image("img_laser#{@n+@s}_beam")
        canvas.put(img, 0, 0)
      end
    end

    $game.images[@image_key] = canvas
  end
  def draw(surf)
    surf.put($game.images[@image_key], 0, 0)
  end
end

# up to three lasers in either direction
class Lasers
  def init_sdl(surf)
    @image_key = key
    return if $game.images[@image_key]

    canvas = SDL::Surface.new(SDL::SWSURFACE, $game.theme['square_size'], 
    $game.theme['square_size'], surf)
    canvas.set_color_key(SDL::SRCCOLORKEY, canvas[0,0])

    if @n + @s > 0 and @w + @e == 0
      img = $game.load_image("img_laser#{@n+@s}_beam")
      canvas.put(img,0,0)
    elsif @n + @s == 0 and @w + @e > 0
      img = $game.load_image("img_laser#{@w+@e}_beam")
      rotate(img, canvas, 90)
    elsif @n + @s > 0 and @w + @e > 0
      img = $game.load_image("img_laser#{@n+@s}_beam")
      img2 = $game.load_image("img_laser#{@w+@e}_beam")
      canvas.put(img,0,0)
      rotate(img2, canvas, 90)
    end

    $game.images[@image_key] = canvas
  end
end
