class Pit

  # this very complex condition tree determines
  # how the pit will look, which is dependant on 
  # pits in adjacent squares. The deps were computed in init_deps
  def init_sdl(surf)
    @image_key = key
    return if $game.images[@image_key]
    if @adj_pits.empty?
      img = $game.load_image('img_pit')
    else
      adjstr = @adj_pits.to_s
      case adjstr.size
      when 4 # O shaped
        img = $game.load_image("img_pit_nwse")
        add_corners(img)
      when 1 # U shaped
        img = $game.load_image("img_pit_w")
        case adjstr
        when "n" then rotate(img,img, 90)
        when "e" then rotate(img,img, 180)
        when "s" then rotate(img,img, 270)
        end
      when 3 # _ shaped
        img = $game.load_image("img_pit_nwe")
        case adjstr
        when "nse" then rotate(img,img, 90)
        when "wse" then rotate(img,img, 180)
        when "nws" then rotate(img,img, 270)
        end
        add_corners(img)
      when 2 # || shaped or L shaped
        case adjstr
        when "ns", "we"
          img = $game.load_image("img_pit_we")
          rotate(img,img, 90) if adjstr == "ns"
        else
          img = $game.load_image("img_pit_nw")
          case adjstr
          when "ne" then rotate(img,img, 90)
          when "se" then rotate(img,img, 180)
          when "ws" then rotate(img,img, 270)
          end
          add_corners(img)
        end
      end
    end
    $game.images[@image_key] = img
  end

  def add_corners(img)
    # the corner img is oriented nw
    corner = $game.load_image("img_pit_corner")
    img.put(corner, 0, 0) if @corners.present_at?(N) # nw
    rotate(corner, img, 90) if @corners.present_at?(E) # ne
    rotate(corner, img, 180) if @corners.present_at?(S) # se
    rotate(corner, img, 270) if @corners.present_at?(W) # sw
  end

end
