class Square
  attr_accessor :surface

  def init_sdl(surf)
    size = $game.theme['square_size']
    @surface = SDL::Surface.new(Defs::Gfx::SDLFLAGS, size, size, surf)
    @floor.init_sdl(surf)
    for e in @elements
      e.init_sdl(surf)
    end
    @walls.init_sdl(surf)
    dirty
  end

  def draw(surf)
    return unless dirty?
    draw_bottom(surf)
    draw_top(surf)
    clean
  end

  def draw_bottom(surf)
    @floor.draw(@surface)
    surf.put(@surface, @x, @y)
  end

  def draw_top(surf)
    for e in @elements
      e.draw(@surface)
    end
    @walls.draw(@surface)
    surf.put(@surface, @x, @y)
  end

  # draw only the cached surface
  def draw_cached(surf)
    return unless dirty?
    surf.put(@surface, @x, @y)
    clean
  end

end
