class Walls
  include Tools

  # draw is defined dynamically because
  # most squares have empty walls (saves exec)
  def draw(surf)
  end

  # walls are special.. they have to be joined by a corner image
  # and there can be up to three in any configuration on a sqyare
  def init_sdl(surf)
    @image_key = key

    def self.draw(surf)
      surf.put($game.images[@image_key], 0, 0)
    end

    return if $game.images[@image_key]

    # construct the image for this wall set
    canvas = SDL::Surface.new(SDL::SWSURFACE, $game.theme['square_size'],
    $game.theme['square_size'], surf)
    # because canvas starts out black, set color key to black to make it
    # transparent
    canvas.set_color_key(SDL::SRCCOLORKEY, canvas[0,0])
    wall = $game.load_image('img_wall')
    corner = $game.load_image('img_wall_corner')

    # blit the walls first (initial wall is S)
    rotate(wall, canvas, 0) unless @s.nil?
    rotate(wall, canvas, 90) unless @w.nil?
    rotate(wall, canvas, 180) unless @n.nil?
    rotate(wall, canvas, 270) unless @e.nil?
    # now blit the joints (initial join it SE)
    rotate(corner, canvas, 0) if @s and @e
    rotate(corner, canvas, 90) if @s and @w
    rotate(corner, canvas, 180) if @n and @w
    rotate(corner, canvas, 270) if @n and @e

    $game.images[@image_key] = canvas
  end
end
