# Describes somethig that can appear multiple times per square, one
# for each side.
class Sides < Element
  # input is any number of Facing objects: Sides.new(Facing.n, Facing.w)
  def initialize(*facings)
    @n = facings.find {|f| f == N}
    @w = facings.find {|f| f == W}
    @s = facings.find {|f| f == S}
    @e = facings.find {|f| f == E}
  end
  def add(face)
    case face
    when N then @n = N
    when W then @w = W
    when S then @s = S
    when E then @e = E
    end
  end
  def each
    yield @n if @n
    yield @w if @w
    yield @s if @s
    yield @e if @e
  end
  # do we have something in that direction?
  def has_direction?(dir)
    present_at?(dir)
  end
  def present_at?(direction)
    return case direction
      when N then not @n.nil?
      when W then not @w.nil?
      when S then not @s.nil?
      when E then not @e.nil?
      else false
    end
  end
  def empty?
    return true if @n.nil? and @w.nil? and @s.nil? and @e.nil?
    false
  end
  def inspect; to_s end
  def to_s
    "#{@n}#{@w}#{@s}#{@e}"
  end
  def sides
    [@n, @w, @s, @e]
  end
end
