class Card
  attr_reader :name
  attr_accessor :priority, :rank
  def initialize(name, rank, priority=nil)
    @name, @rank, @priority = name, rank, priority
  end
  def to_s
    @name + "(#{@priority})"
  end
  alias inspect to_s
  def ==(other)
    return false unless other.kind_of?(Card)
    other.name == @name and other.priority == @priority
  end
  def ===(other); self == other end
  def <=>(other)
    @priority <=> other.priority
  end
  def copy; Card.new(@name, @rank, @priority) end
  def *(num)
    arr = []; num.times {arr << Card.new(@name, @rank)}; arr
  end
end
