class GameType
  def initialize(name, *objectives)
    @name = name
    @met_objective = nil
    @objectives = objectives
    @robot_lives = 3
  end
  def adjust(game)
    for robot in game.game_robots
      start = game.board[0,0] # kludge: define start_square somehow
      robot.row, robot.col = start.row, start.col
      robot.spawn = start.row, start.col
      robot.lives = @robot_lives
    end
  end
  def text(game)
    @met_objective.text(game) + "\nGame Over"
  end
  def game_over?
    check($game)
  end
  def check(game)
    for o in @objectives
      next unless o.check(game)
      @met_objective = o
      return true
    end
    false
  end
  # describe the gametype
  def to_s
    buff = "The game is #{@name}.\n"
    return buff + "There is no objective." if @objectives.size == 0
    buff += "In order to win, you must:\n\t- "
    buff += @objectives.collect{|o| o.to_s}.join("\n\t- ")
    buff
  end
end

class LastRobotStanding < GameType
  def initialize
    super("Last Robot Standing", NoWinner.new, LastRobotStandingObjective.new)
  end
end

class DefaultGameType < LastRobotStanding
end

class SinglePlayerExplore < GameType
  def initialize
    super("Single Player Explore")
  end
end

class SinglePlayerGame < GameType
  def initialize
    super("Single Player Game", NoWinner.new)
  end
end
