class Objective
  # returns false if not satisfied or a String containing satisfaction text
  def check(game); false end
  def text(game); "" end
end

class NoWinner < Objective
  def check(game)
    game.game_robots.size == 0
  end
  def text(game)
    "Nobody left to win. Nice going guys..."
  end
  def to_s
    "Have at least 1 life left on the winning turn"
  end
end

class LastRobotStandingObjective < Objective
  def check(game)
    game.game_robots.size == 1
  end
  def text(game)
    winner = game.game_robots.first
    "#{winner.name} is the last robot standing. #{winner.name} wins the game!"
  end
  def to_s
    "Be the only surviving robot"
  end
end
