require 'socket'
require 'fcntl'

# This class wraps socket to handle marshalling and other
# conveniences

# TODO: fix the goddamn errors thrown upon closing sockets

class Session
  MSG_START = 0x1001
  @@log = Logger['bf::session']

  def initialize(socket)
    @socket = socket
    @socket.sync = true
    @socket.setsockopt(Socket::SOL_TCP, Socket::TCP_NODELAY, 1)
    @socket.fcntl(Fcntl::F_SETFL, Fcntl::O_NONBLOCK)
    @addr = "botfrenzy://#{@socket.addr[3]}:#{@socket.addr[1]}"
    @peeraddr = "botfrenzy://#{@socket.peeraddr[3]}:#{@socket.peeraddr[1]}"
    @@log.info {"Created session from #{@addr} to #{@peeraddr}"}
  end

  def close; @socket.close end

  def connected?; not @socket.nil? and not @socket.closed? end

  # this blocks... bad!
  def finished?; @socket.eof? end
  
  def session_send(sig, obj=nil)
    @@log.debug {"Sending #{sig.inspect} to #{@peeraddr}"}
    begin
      Marshal.dump([sig, obj], @socket)
    rescue Exception => e
      @@log.error "Failed to write to #{@peeraddr}"
      @@log.warn {"Method: #{sig.inspect}"}
      @@log.warn {"Object: #{obj.inspect}"}
      raise e
    end
  end
  
  def session_get
    data = Marshal.load(@socket)
    @@log.debug {"Got #{data[0].inspect} from #{@peeraddr}"}
    return data
  end
end  
