# utility methods (no netsends)
class GameServer
  
  def game_running?(clientid)
    return false unless $game.game_running?
    nick = $game.players[clientid].nick
    send_cmsg(clientid, "Can't do that, game already in progress") 
    true
  end

  def remove_all_traces(clientid)
    remove(clientid)
    $game.remove(clientid)
    update_players
  end

  # deals with the game state when players drop out
  def update_players 
    $game.end_game if $game.game_robots.size == 0
    shout "Game Over!"
  end

  def valid_gametype(state)
    return false if state.gametype.nil? or not state.gametype.kind_of?(GameType)
    begin
      $game.xml_board, $game.board = BoardFactory.create_from_string(state.xml_board)
      $game.gametype = state.gametype
      return true
    rescue REXML::ParseException
      @log.error "Invalid XML board"
      @log.debug {$game.xml_board}
      return false
    end
  end

end
