# server methods called by client
# specifically those having to do with initiating the game
class GameServer

  ##### the remaining deal with joining games, creating games,
  ##### and playing the game (to go to recvplay.rb instead)

  # first come, first served
  def recv_game_created(clientid, state)
    return if game_running?(clientid)
    name = $game.robots[clientid].name
    if not $game.board.nil? # check to see if game is waiting to start
      send_cmsg(clientid, "Sorry, game already created.")
      return
    end
    if not valid_gametype(state)
      send_cmsg(clientid, "Server: That's not a valid gametype or board.")
      return
    end
    shout "#{name} has created a game."
    shout $game.gametype.to_s
    # For now, all available robots become part of the game
    $game.game_robots = $game.robots.values
    # stupid default game for 1 player
    if $game.game_robots.size == 1
      $game.gametype = SinglePlayerExplore.new
    end
    # send the game type and board to everyone else
    state = DeltaState.new :xml_board
    for id, client in @clients
      netsend id, :recv_game_created, state unless clientid == id
    end
    start_game
  end

  # not in dev yet
  def recv_vote_start(clientid)
    return if game_already?(clientid)
    if $game.game_robots.include?($game.robots[clientid])
      shout "#{$game.robots[clientid].name} really really wants to start."
    else
      shout "#{$game.robots[clientid].name} is ready to play."
      synch do
        $game.game_robots << $game.robots[clientid]
      end
      start_game if $game.game_robots.size == $game.all_robots.size
    end
  end
end
