require 'bf/state/gamestate'

# like gamestate, but just stores a snapshot of serverside data
# along with client-specific game data (but that goes in ui/)
class ClientGameState < GameState
  # special copy method that doesn't erase previous data if new
  # data is nil
  def set_state(data)
    if data.game_robots
      for robot in data.game_robots
        match = @game_robots.find {|r| r==robot}
        if match
          match.set_state(robot)
        else @game_robots << robot
        end
      end
    end
    @robot.set_state(data.robot) if data.robot
    @turn = data.turn if data.turn
    @board = data.board if data.board
    @xml_board = data.xml_board if data.xml_board
    @turn_history = data.turn_history if data.turn_history
    @game_history = data.game_history if data.game_history
    @gametype = data.gametype if data.gametype
  end
  def copy(*fields)
    s = clone
    for m in s.public_methods
      next unless m[-1..-1] == "=" and m[0..0] != "="
      s.send(m, nil) unless fields.include?(m[0..-2].intern)
    end
    s
  end
end
