#include "ruby.h"
#include "SDL/SDL.h"

/* we optimize the event loop with this C extension */

static VALUE t_event_loop(VALUE self, VALUE obj)
{
  SDL_Event event;
  VALUE mainw;
  ID quitm;

  mainw = rb_iv_get(self, "@main");
  quitm = rb_intern("quit");

  while ( SDL_WaitEvent(&event) >= 0 ) {
    switch (event.type) {
      case SDL_KEYDOWN: 
        {
          printf("Key pressed!\n");
        }
        break;
      case SDL_QUIT:
        {
          rb_funcall(mainw, quitm, 0);
        }
        break;
    }
  }

  return Qnil;
}

VALUE cApp;

void Init_App() {
  cApp = rb_define_class("App", rb_cObject);
  rb_define_method(cApp, "event_loop", t_event_loop, 0);
}
