# just takes up space, like a null button
class FillSquare < Widget
  def initialize(hash={})
    super(hash)
  end
  def init_sdl
    @surface = create_surface(@w, @h)
  end
end

class Label < Widget
  TEXTPAD = 4
  def initialize(hash)
    super(hash)
    @label = " " if @label.empty?
    @color = (hash[:color] or [255,255,255])
    @size = (hash[:size] or 12)
  end
  def label=(new)
    @label=label
    init_sdl
    dirty
  end
  def init_sdl
    if not @font
      @font = $game.load_font('font_bold', @size)
    end
    tw, th = @font.text_size(@label)
    @w = tw+TEXTPAD*2
    @h = th+TEXTPAD*2
    px = ((@w - tw) / 2.0).to_i
    py = ((@h - th) / 2.0).to_i
    @surface = create_surface(@w, @h)
    @font.drawSolidUTF8(@surface, @label, px, py, *@color)
  end
end

# button with label
class LabelButton < Button
  TEXTPAD = 4
  def initialize(hash)
    super(hash)
    @label = " " if @label.empty?
    @color = (hash[:color] or [255,255,255])
    @size = (hash[:size] or 14)
  end
  def init_sdl
    font = $game.load_font('font_bold', @size)
    tw, th = font.text_size(@label)
    @w = tw+TEXTPAD*2+PAD*2
    @h = th+TEXTPAD*2+PAD*2
    super
    px = ((@w - tw) / 2.0).to_i
    py = ((@h - th) / 2.0).to_i
    font.drawSolidUTF8(@hi, @label, px, py, *@color)
    font.drawSolidUTF8(@unhi, @label, px, py, *@color)
    @parent.resized = true
  end
end
