# not using this! it's too slow

# object that encapsulates all the scroll data
class Slider < Widget
  attr_reader :view_w, :subject_w, :slider_w, :slider_pos

  # this will start out the same size as the bar minus padding
  def initialize(hash={})
    super(hash)
    @slider_pos = 0
    @pressed = false
    @vertical = hash[:vertical]
    @view_w = (@vertical ? @h : @w)
    connect_method(SDL::Event2::MouseButtonDown, :on_mouse_down)
    connect_method(SDL::Event2::MouseButtonUp, :on_mouse_up)
    connect_method(SDL::Event2::MouseMotion, :on_mouse_move)
  end

  def view_w=(neww)
    @view_w = neww
    @slider_w = view_ratio * @view_w
    @slider_pos = @view_w - @slider_w if @slider_pos > @view_w - @slider_w
    dirty
  end
  def subject_w=(neww)
    @subject_w = neww
    @slider_w = view_ratio * @view_w
    @slider_pos = 0 if @view_w >= @subject_w
    dirty
  end
  def view_ratio
    return 1.0 if @view_w >= @subject_w
    1.0 * @view_w / @subject_w
  end
  # slide the bar dw
  def slide_bar(dw)
    if @slider_pos + dw < 0
      @slider_pos = 0
    elsif @slider_pos + dw > @view_w - @slider_w
      @slider_pos = @view_w - @slider_w
    else
      @slider_pos += dw
    end
    dirty
  end
  # returns the w coord on the subject that should be top left in view
  def subj_pos
    r = view_ratio
    return 0 if r == 1.0
    (@slider_pos / (r*(1.0-r)))
  end

  def init_sdl
    @surface = SDL::Surface.new(Defs::Gfx::SDLFLAGS, @w, @h, @@root_surface)
    @surface.set_color_key(SDL::SRCCOLORKEY, @surface[0,0])
  end
 
  def on_mouse_down(event)
    return unless event.button == 1
    @pressed = true
    focus
    dirty
  end
  
  def on_mouse_up(event)
    return unless event.button == 1
    @pressed = false
    unfocus
    dirty
    @dx, @dy = 0, 0
  end

  # this only happens on focus (see App#event_loop)
  # argh, still very slow
  def on_mouse_move(event)
    slide_bar(@vertical ? event.yrel : event.xrel) 
  end

  def draw(root_surf, dx, dy)
    return unless dirty?
    if @view_w < @subject_w
      draw_slider
      root_surf.put(@surface, dx+@x, dy+@y)
    end
    clean
  end

  def draw_slider
    @surface.fill_rect(0,0,@w,@h,0x00000000)
    pad = Theme['pad']
    color = (@pressed ? Theme['scroll_highlight'] : Theme['scroll_unhighlight'])
    if @vertical
      args1 = [0, @slider_pos, @w, @slider_w]
      args2 = [0+pad, @slider_pos+pad, @w-2*pad, @slider_w-2*pad, color]
    else 
      args1 = [@slider_pos, 0, @slider_w, @h]
      args2 = [@slider_pos+pad, pad, @slider_w-2*pad, @h-2*pad, color]
    end
    draw_subborder(@surface, Theme['scroll_highlight'], Theme['pad'], *args1)
    @surface.fill_rect(*args2)
  end

  # override this
  def inside?(px, py)
    res = false
    if @vertical
      res = true if py > @slider_pos and py < @slider_pos + @slider_w
    else
      res = true if px > @slider_pos and px < @slider_pos + @slider_w
    end
    res
  end
end

class ScrollBar < Widget
  Theme['pad'] = 2
  attr_reader :slider

  def initialize(hash)
    super(hash)
    case hash[:orientation]
    when "vertical" then @vertical = true
    when "horizontal" then @vertical = false
    end
    #connect_method(SDL::Event2::MouseButtonDown, :on_mouse_down)
    pad = Theme['pad']
    @slider = Slider.new(:x=>pad, :y=>pad, :w=>@w-2*pad, :h=>@h-2*pad, :vertical=> @vertical)
    add @slider
  end
  def init_sdl
    @surface = SDL::Surface.new(Defs::Gfx::SDLFLAGS, @w, @h, @@root_surface)
    draw_border(@surface, Theme['window_border'], Theme['pad'])
  end
  def on_moue_down(event)
    # jump around
  end
  def find_widget(px,py)
    (@slider.inside?(px-@x, py-@y) ? @slider : self)
  end
end

class HScrollBar < ScrollBar
  def initialize(hash)
    hash[:orientation]="horizontal"
    super(hash)
  end
end

class VScrollBar < ScrollBar
  def initialize(hash)
    hash[:orientation]="vertical"
    super(hash)
  end
end

class ScrollWidget < Widget
  Theme['pad'] = 2
  COLOR = 0x000000FF
  attr_reader :subject

  def initialize(hash={})
    super(hash)
    ss = Theme['scroll_size']
    hx = @w - ss
    hy = @h - ss
    @hscrollbar = HScrollBar.new(:x=>0,:y=>hy,:w=>hx,:h=>ss)
    @vscrollbar = VScrollBar.new(:x=>hx,:y=>0,:w=>ss,:h=>hy)
    add(@hscrollbar, @vscrollbar)
  end
  def init_sdl
    if @w and @h and @w > 0 and @h > 0
      ss = Theme['scroll_size']
      @surface = SDL::Surface.new(Defs::Gfx::SDLFLAGS, @w-ss, @h-ss, @@root_surface)
      draw_subborder(@surface, Theme['window_border'], Theme['pad'], 0, 0, @w-ss+Theme['pad'], @h-ss+Theme['pad'])
      @view = SDL::Surface.new(Defs::Gfx::SDLFLAGS, @w-Theme['pad']-ss, @h-Theme['pad']-ss, @@root_surface)
    end
  end
  def subject=(subj)
    @subject = subj
    @hscrollbar.slider.subject_w = subj.w
    @vscrollbar.slider.subject_w = subj.h
  end
  def draw(root_surf, dx, dy)
    return unless dirty?
    # draw the special view area
    if not @subject.nil?
      sx = @hscrollbar.slider.subj_pos
      sy = @vscrollbar.slider.subj_pos
      @subject.draw(@view, 0, 0)
      @surface.put(@view, Theme['pad'], Theme['pad'])
    end
    root_surf.put(@surface, dx+@x, dy+@y)
    @hscrollbar.draw(root_surf, dx+@x, dy+@y)
    @vscrollbar.draw(root_surf, dx+@x, dy+@y)
    clean
  end
end
