# specific to the gui
module GuiTools
  # given a surface, draw a border with color and padding
  def draw_border(surf, color, pad)
    draw_subborder(surf, color, pad, 0, 0, surf.w, surf.h)
  end
  # draw a border with a specified x,y,w,h on surf
  def draw_subborder(surf, color, pad, x, y, w, h)
    surf.fill_rect(x, y, w, pad, color)
    surf.fill_rect(x, y, pad, h, color)
    surf.fill_rect(x, y+h-pad, w, pad, color)
    surf.fill_rect(x+w-pad, y, pad, h, color)
  end
  def sfrom_hash(hash, *symbols)
    ret = []
    symbols.each do |sym|
      ret << (hash[sym] or hash[sym.to_s])
    end
    return ret[0] if ret.size == 1
    ret
  end
  def ifrom_hash(hash, *symbols)
    return (hash[symbols[0]] or hash[symbols[0].to_s]).to_i if symbols.size==1
    ret = sfrom_hash(hash, *symbols)
    ret.map {|e| e.to_i}
  end
  def list_split(string)
    return [] if string.nil? or string.strip.empty?
    string.split(/\s*,\s*/)
  end
  def rotate(src, dest, angle)
    SDL.transformBlit(src, dest, angle, 
      1.0, 1.0, src.w/2.0, src.h/2.0, src.w/2.0, src.h/2.0, 0)
  end
end
