class ClientUI

  def run
    @app = App.new(self)
    @app.run
  end

  def write_cmsg(msg)
    puts msg
  end

  def quit
    @client.disconnect if network_game? 
    exit
  end

  def recv_server_disconnect
    # do nothing
  end

  def start_programming_phase
  end

  # init board
  def recv_game_created
    @boardui.game_created
  end

  # here's where the magic begins
  # we have a hand and a set of robots, so draw the board
  def start_game
    @boardui.start_game
    @statusbox.update
  end

  def draw_hand(robot = $game.robot)
    @sidebox.children.clear
    for card in robot.hand
      cb = CardButton.new(card)
      @sidebox.add cb
      cb.init_sdl
    end
    @sidebox.resize
    @sidebox.dirty
    # for locked registers
    @registers.re_initialize(robot.registers)
  end

  # for network
  def handle_play
    if @registers.numcards == 5
      @client.play_hand(@registers.collect_play)
    end
  end

  # we recieved a turn $game.turn_history
  def draw_turn
    @boardui.animate_turn
  end

end
