class Animate
  def animate_laserfire(snapshot)
    sbang = $game.images['bang_small']
    size = $game.theme['square_size']

    for s in @delta
      if s.has_lasers? # then put bang on square
        @root.put(sbang, s.x+@widget.x, s.y+@widget.y)
      end
    end
    for r in snapshot.game_robots
      target = r.fire_laser
      if target
        x, y = target.getx, target.gety
        x *= size
        y *= size
        @root.put(sbang, x+@widget.x, y+@widget.y)
      end
    end
    @root.flip
  end

  def old
    prep
    delay = 0.3
    @delta_tiles.each {|t| t.drawbottom(self)}
    snapshot.robots.each {|r| r.draw(self)}
    for robot in snapshot.robots
      tile = @board.get_tile(robot.row, robot.col)
      # board lasers firing at robots
      blit_smallexplode(robot) if tile.has_lasers?
      # robots firing at each other
      target = @board.find_robot_los(robot, robot.facing, 
                 robot.row, robot.col, snapshot.robots)
      if target and not target == robot
        blit_shot(robot, target) 
        delay += 0.1
      end
    end
    @delta_tiles.each {|t| t.drawtop(self)}
    update
    sleep delay
    clean
  end
  def blit_shot(robot, target)
    # TODO: blit laser
    blit_smallexplode(target)
  end
  # order matters! pass tiles first
  def blit_smallexplode(target)
    blit(@images['smallexplode'], [target.getx, target.gety])
  end
end
