class Animate
  def animate_pitdeath(snapshot)
    pit = @delta.find {|s| s.has_pit?}
    rob = nil
    rob = snapshot.game_robots.find{|r| r.row == pit.row and r.col == pit.col}
    return unless rob

    base = case rob.facing
    when N then 0.0
    when E then 90.0
    when S then 180.0
    when W then 270.0
    end
    degrees = 225 # how much to spin the robot while falling
    scale = 0.5 # how small to shrink

    r = $game.images[rob.key]
    size = $game.theme['square_size']
    y, x = rob.row * size + size/2.0, rob.col * size + size/2.0

    i = 0
    while i < degrees
      rot = base + Math::sin(i/360.000)*360.000
      zoom = 1.000 - scale * (i/(degrees*1.0))

      @root.put(pit.surface, pit.x+@widget.x, pit.y+@widget.y)

      SDL.transformBlit(r, @root, rot, zoom, zoom, 
      r.w/2, r.h/2, x+@widget.x, y+@widget.y, 0)

      @root.flip
      i+=5
    end

  end
end
