# for now, just draw the board

class BoardView < Widget
  attr_accessor :robots
  attr_reader :animate
  def initialize(hash)
    super(hash)
    @animate = Animate.new
    @robots = []
  end

  def init_sdl
    @surface = SDL::Surface.new(Defs::Gfx::SDLFLAGS, @w, @h, @@root_surface)
    @animate.init_sdl(@@root_surface, self)
  end

  def draw(surf, px, py)
    return unless dirty?
    if @board
      @board.draw_cached(@surface)
      @robots.each { |r| r.draw(@surface) }
    end
    surf.put(@surface, px+@x, py+@y)
    clean
  end

  def game_created
    @board = $game.board
    @board.init_sdl(@surface)
    @board.draw(@surface) # so that draw_cached may be used later
    dirty
  end

  def start_game
    @robots = $game.game_robots
    for r in @robots
      r.init_sdl(@surface)
    end
    dirty
  end

  def animate_turn
    @animate.animate
  end
end
