#t the label is simply the to_s version of a Card
# the card itself should have the image initialized
# and stashed in $game.images

class CardButton < IconButton
  attr_reader :card
  def initialize(card)
    @card = card # the GC shouldn't get rid of this card
    args = {
      :w =>50+PAD*2,
      :h =>75+PAD*2,
      :label => card.to_s
    }
    super(args)
  end
  def init_sdl
    @card.init_sdl(@surface)
    @icon = $game.images[@card.key]
    super
  end
  def draw(surf, px, py)
    super(surf, px, py)
    @card.draw(surf, px+@x+PAD, py+@y+PAD)
  end
  def on_selected(event)
    @active = false
    @pressed = false
    unhighlight

    top = @parent.parent
    # move the button to the other box
    case @parent
    when top.sidebox
      if top.registers.add_card self
        top.sidebox.remove self
        self.parent = top.registers
        top.sidebox.resize.dirty
      end
    when top.registers
      if top.registers.remove_card self
        top.sidebox.add self
        top.sidebox.resize.dirty
      end
    end
  end
  def on_old_selected(event)
    # this makes it non-sticky
    @active = false
    @pressed = false
    unhighlight

    top = @parent.parent
    # move the button to the other box
    case @parent
    when top.sidebox
      return if top.play.size == 5
      top.sidebox.remove self
      top.underbox.add self
      top.play << @card
    when top.underbox
      top.underbox.remove self
      top.sidebox.add self
      top.play.delete(@card)
    end
    top.sidebox.resize.dirty
    top.underbox.resize.dirty
  end
end
