ConsoleHelp = <<-EOL
  Console commands:
    /help                  This message
    /quit                  Quit game
    /exit                  Ditto
    /connect <server>      Connect to <server>
    /start                 Begin game
EOL

# commands that can be invoked from either a gui event or console
class ClientUI
  def start(*data)
    case data[0]
    when "server" then server_setup
    when "game" then @client.oneway :vote_start
    else @ui.write_cmsg "Start what? Options are: server game"
    end
  end
  
  def stop(*data)
    case data[0]
    when "server" then stop_server
    else @ui.write_cmsg "Stop what? Options are: server"
    end
  end

  def quit(*data); quit end

  def help(*data)
    @ui.write_cmsg ConsoleHelp
  end
  
  def connect(*data)
    return if $cstate.connected?
    @client.connect
  end
  
  def nick(*data)
    return if data.size == 0
    @client.set_nick(data[0])
  end
  
  def replay(*data)
  end
  
  def disconnect(*data)
    @client.disconnect
  end
end
