# TODO: draw a bang on locked registers
# TODO: we can put images in slots (designed with this in mind)
class RegisterWidget < Hbox
  attr_reader :numcards

  def initialize(hash)
    @locked = false
    @num_locked = 0
    @numcards = 0
    @slots = []
    @regw = 50 + Button::PAD * 2
    @regh = 75 + Button::PAD * 2
    hash[:w] = @regw * 6
    hash[:h] = @regh
    super(hash)

    5.times do |i|
      fill = FillSquare.new(:h=>@regh, :w=>@regw)
      @slots << fill
    end
    add *@slots
    arrange(@children, @w)
  end

  # given the registers, fill with locked registers
  def re_initialize(regs)
    @locked = false
    @numcards = 0
    @num_locked = 0
    for r in regs
      if r.locked?
        cb = CardButton.new(r.card)
        cb.hicolor = 0x00FF0000
        def cb.on_selected(event)
          @active = false
          @pressed = false
          unhighlight
        end
        @children[r.num-1] = cb
        cb.parent = self
        cb.x = (r.num-1) * @regw
        @slots[r.num-1].parent = nil
        @numcards += 1
        @num_locked += 1
      else
        @children[r.num-1] = @slots[r.num-1]
        @slots[r.num-1].parent = self
      end
    end
    @children.each {|c| c.init_sdl}
    dirty
  end

  # returns play or nil, locks register widget
  def collect_play
    return nil if @numcards != 5
    @locked = true
    @children[0...(5-@num_locked)].map { |cb| cb.card }
  end

  # add a card from hand, called by cardbutton
  def add_card(cb)
    return false if @numcards == 5 or @locked
    # next to last free register
    for i in 0..4
      break if @children[i].kind_of?(FillSquare)
    end
    @slots[i].parent = nil
    @children[i] = cb
    cb.parent = self
    cb.y = 0
    cb.x = i * @regw
    @numcards += 1
    dirty
    true
  end

  # this is called from the cardbutton, asking to remove itself
  def remove_card(cb)
    return false if @locked
    for i in 0..4
      break if @children[i] == cb
    end
    @slots[i].parent = self
    @children[i] = @slots[i]
    cb.parent = nil
    @numcards -= 1
    dirty
    true
  end
end
